package dev.shadowsoffire.apotheosis.adventure.client;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.blaze3d.systems.RenderSystem;
import java.util.ArrayList;
import java.util.List;
import net.minecraft.ChatFormatting;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.gui.components.Button;
import net.minecraft.network.chat.CommonComponents;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.resources.ResourceLocation;

public class SimpleTexButton extends Button {
  protected final ResourceLocation texture;
  
  protected final int xTexStart;
  
  protected final int yTexStart;
  
  protected final int textureWidth;
  
  protected final int textureHeight;
  
  protected Component inactiveMessage = CommonComponents.f_237098_;
  
  public SimpleTexButton(int pX, int pY, int pWidth, int pHeight, int pXTexStart, int pYTexStart, ResourceLocation texture, Button.OnPress pOnPress) {
    this(pX, pY, pWidth, pHeight, pXTexStart, pYTexStart, texture, 256, 256, pOnPress);
  }
  
  public SimpleTexButton(int pX, int pY, int pWidth, int pHeight, int pXTexStart, int pYTexStart, ResourceLocation texture, int pTextureWidth, int pTextureHeight, Button.OnPress pOnPress) {
    this(pX, pY, pWidth, pHeight, pXTexStart, pYTexStart, texture, pTextureWidth, pTextureHeight, pOnPress, CommonComponents.f_237098_);
  }
  
  public SimpleTexButton(int pX, int pY, int pWidth, int pHeight, int pXTexStart, int pYTexStart, ResourceLocation texture, int pTextureWidth, int pTextureHeight, Button.OnPress pOnPress, Component pMessage) {
    this(pX, pY, pWidth, pHeight, pXTexStart, pYTexStart, texture, pTextureWidth, pTextureHeight, pOnPress, f_252438_, pMessage);
  }
  
  public SimpleTexButton(int pX, int pY, int pWidth, int pHeight, int pXTexStart, int pYTexStart, ResourceLocation texture, int pTextureWidth, int pTextureHeight, Button.OnPress pOnPress, Button.CreateNarration pOnTooltip, Component pMessage) {
    super(pX, pY, pWidth, pHeight, pMessage, pOnPress, pOnTooltip);
    this.textureWidth = pTextureWidth;
    this.textureHeight = pTextureHeight;
    this.xTexStart = pXTexStart;
    this.yTexStart = pYTexStart;
    this.texture = texture;
  }
  
  public dev.shadowsoffire.apotheosis.adventure.client.SimpleTexButton setInactiveMessage(Component msg) {
    this.inactiveMessage = msg;
    return this;
  }
  
  public void m_264152_(int pX, int pY) {
    m_252865_(pX);
    m_253211_(pY);
  }
  
  public void m_87963_(GuiGraphics gfx, int pMouseX, int pMouseY, float pPartialTick) {
    int yTex = this.yTexStart;
    if (!m_142518_()) {
      yTex += this.f_93619_;
    } else if (m_274382_()) {
      yTex += this.f_93619_ * 2;
    } 
    RenderSystem.enableDepthTest();
    gfx.m_280163_(this.texture, m_252754_(), m_252907_(), this.xTexStart, yTex, this.f_93618_, this.f_93619_, this.textureWidth, this.textureHeight);
    if (m_274382_())
      renderToolTip(gfx, pMouseX, pMouseY); 
  }
  
  public void renderToolTip(GuiGraphics gfx, int pMouseX, int pMouseY) {
    if (m_6035_() != CommonComponents.f_237098_ && m_274382_()) {
      MutableComponent mutableComponent;
      Component primary = m_6035_();
      if (!this.f_93623_)
        mutableComponent = primary.m_6881_().m_130940_(ChatFormatting.GRAY); 
      List<Component> tooltips = new ArrayList<>();
      tooltips.add(mutableComponent);
      if (!this.f_93623_ && this.inactiveMessage != CommonComponents.f_237098_)
        tooltips.add(this.inactiveMessage); 
      gfx.m_280666_((Minecraft.m_91087_()).f_91062_, tooltips, pMouseX, pMouseY);
    } 
  }
}
